<?php

namespace App\Http\Controllers\Auth;

use App\Http\Controllers\Controller;
use App\Providers\RouteServiceProvider;
use Carbon\Carbon;
use Illuminate\Foundation\Auth\AuthenticatesUsers;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Redirect;

class LoginController extends Controller
{
    /*
    |--------------------------------------------------------------------------
    | Login Controller
    |--------------------------------------------------------------------------
    |
    | This controller handles authenticating users for the application and
    | redirecting them to your home screen. The controller uses a trait
    | to conveniently provide its functionality to your applications.
    |
    */

    use AuthenticatesUsers;

    /**
     * Where to redirect users after login.
     *
     * @var string
     */
    protected $redirectTo = RouteServiceProvider::HOME;

    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        $this->middleware('guest')->except('logout');
    }
    protected function authenticated()
    {
        if (  Auth::user()->hasRole('super-admin') ) {// do your magic here
            return Redirect::to('/dashboard');
        }
        else if(Auth::user()->hasRole('admin') )
        {
            return Redirect::to('/admin/dashboard');
        }


        $subcription = SanitizerSubscription::where('user_id',Auth::user()->id)->where('status','paid')->get();
        $ad_subs = AdvertisementSubscription::where('user_id',Auth::id())->where('status','paid')->get();
        if(!empty($subcription))
        {
            foreach ($subcription as $item)
            {
                $mytime = Carbon::now();

                if($item->expire_date<$mytime->toDateTimeString())
                {
                    $update = SanitizerSubscription::find($item->id);
                    $update->status ='expired';
                    $update->save();
                }
            }
        }

        if(!empty($ad_subs))
        {
            foreach ($ad_subs as $item)
            {
                $mytime = Carbon::now();

                $date = new DateTime($item->updated_at);
                $interval = new DateInterval('P'.$item->months.'M');

                $date->add($interval);
                $date->format('Y-m-d') ;


                if($date->format('Y-m-d')<$mytime->toDateTimeString())
                {
                    $update = AdvertisementSubscription::find($item->id);
                    $update->status ='expired';
                    $update->save();
                    AdvertisementFiles::where('ad_subsc_id',$item->id)->update(['status' => 'expired']);
                }
            }
        }
        return redirect()->intended();
    }
}
