<?php

namespace App\Http\Controllers;

use App\Countries;
use App\CustomerAddress;
use App\Domains;
use App\DomainUsers;
use App\Orders;
use App\Payments;
use App\States;
use App\Theme;
use App\User;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Crypt;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Mail;
use Illuminate\Support\Facades\URL;
use Illuminate\Support\Str;
use phpDocumentor\Reflection\Types\False_;
use Session;
use Stripe;
use Illuminate\Support\Facades\Redirect;

class CartController extends Controller
{
    public function index(Request $request)
    {
        if ($request->has('key')) {
            $this->removeCart($request->key);
            $item = Session::get('id');
            if (count($item) > 0) {
                return Redirect::to('/cart');

            } else {

                return view('cart');

            }

        } else {
            if ($request->has('domain')) {
                $domain = Domains::find(base64_decode($request->domain));
                if ($domain->sold == "0") {
                    $item = Session::get('id');
                    if (!empty($item)) {

                        if (!in_array(base64_decode($request->domain), $item)) {
                            for ($i = 0; $i < count($item); $i++) {
                                if(isset($item[$i]))
                                {
                                    $idArr[] =  $item[$i];
                                }

                            }
                            $idArr[count($item)] = base64_decode($request->domain);
                            session(['id' => $idArr]);
                            $domains = Domains::whereIn('id', Session::get('id'))->get();
                            $theme = Theme::where('domain_id',base64_decode($request->domain))->first();
                            return view('cart', compact('domains','theme'));
                        } else {
                            $domains = Domains::whereIn('id', Session::get('id'))->get();
                            $theme = Theme::where('domain_id',base64_decode($request->domain))->first();
                            return view('cart', compact('domains','theme'));
                        }

                    } else {
                           $theme = Theme::where('domain_id',base64_decode($request->domain))->first();
                        $idArr[0] = base64_decode($request->domain);
                        session(['id' => $idArr]);
                        $domains = Domains::whereIn('id', Session::get('id'))->get();
                        return view('cart', compact('domains','theme'));
                    }

                }

            } else {
                if (!empty(Session::get('id'))) {
                    $domains = Domains::whereIn('id', Session::get('id'))->get();
                    if(count(Session::get('id'))>0)
                    {
                        $dID = Session::get('id');

                        $theme = Theme::where('domain_id',$dID[0])->first();
                        return view('cart', compact('domains','theme'));
                    }

                    return view('cart', compact('domains'));
                }
                return view('cart');
            }
        }
        return redirect()->back()->withMessage("This domain is already sold");
    }

    public function removeCart($key)
    {
        $item = Session::get('id');
        $idArr = array();
        if (!empty($item)) {
            for ($i = 0; $i < count($item); $i++) {
                if ($i != $key) {
                    $idArr[$i] = $item[$i];
                }

            }
            if (count($item) > 0) {
                session(['id' => $idArr]);

            } else {

                Session::forget('id');

            }

        }
        return false;
    }

    public function checkOut(Request $request)
    {
        if(app('router')->getRoutes()->match(app('request')->create(URL::previous()))->getName() == 'cart' ||
            app('router')->getRoutes()->match(app('request')->create(URL::previous()))->getName() == 'checkout' ||
        app('router')->getRoutes()->match(app('request')->create(URL::previous()))->getName() == 'escrow')
        {
            $countries = Countries::all();
            $item = Session::get('id');
            if ($request->has('key')) {
                $this->removeCart($request->key);

                if (count($item) > 0) {
                    return Redirect::to('/checkout');

                } else {

                    return view('checkout',compact('countries'));

                }


            } else {
                if (!empty($item)) {
                    $domains = Domains::whereIn('id', Session::get('id'))->get();
                    if($request->has('payment'))
                    {
                        if($request->payment=='paypal')
                        {
                            $paypal = 'paypal';
                            return view('checkout', compact('domains','paypal','countries'));
                        }
                        elseif($request->payment=='escrow')
                        {
                            $escrow = 'escrow';
                            return view('checkout', compact('domains','escrow','countries'));
                        }
                    }
                    return view('checkout', compact('domains','countries'));

                } else {

                    return view('checkout',compact('countries'));

                }
            }

        }

    }

    public function checkOutDone(Request $request)
    {

        $this->validate($request, [

            'card' => 'required|regex:/^[0-9\s]*$/',
            'cvc' => 'required|numeric',
            'month' => 'required|numeric',
            'year' => 'required|numeric',
            'first_name' => 'required|string|max:30',
            'last_name' => 'required|string|max:30',
            'email' => 'required|email',
            'phoneCode' => 'required|string|max:30',
            'phone' => 'required|string|max:50',
            'card_name' => 'required|string|max:30',
            'address_1' => 'required|string|max:200',
            'address_2' => 'nullable|string|max:200',
            'city' => 'required|string|max:45',
            'state' => 'required|string|max:45',
            'zip_postal_code' => 'required|string|max:25',
            'g-recaptcha-response' => 'required',

        ]);
        try {

            $password = "";
                $email = "";
            $price = 0;
            Stripe\Stripe::setApiKey(env("STRIPE_SECRET" ));
            $order = new Orders();
            $user = User::where('email', $request->email)->first();
            if (empty($user)) {
                $email =$request->email;
                $password = Str::random(10);
                $user = new User();
                $user->first_name = $request->first_name;
                $user->last_name = $request->last_name;
                $user->email = $request->email;
                $user->password =  Hash::make($password);
                $user->save();
                $user_id = $user->id;
            } else {
                $user_id = $user->id;
            }


            $domains = $domains = Domains::whereIn('id', Session::get('id'))->get();
            foreach ($domains as $domain) {
                if ($domain->sold != "0") {
                    return redirect()->back()->withErrors($domain->domain_name . " already sold");
                }
                $price = $price + $domain->price;
            }

            $price = round($price);

                $customer = \Stripe\Customer::create([
                    'email' => $request->email,
                    'description' => $request->first_name . " " . $request->last_name,
                    'source' => $request->stripeToken,
                ]);
                $encrypted = Crypt::encryptString($customer->id);


            $statusPaid = Stripe\Charge::create([
                "amount" => 100 * $price,
                "currency" => "usd",
                "description" => $request->first_name . " " . $request->last_name . " with Email " . $request->email . " purchased domains ",
                "customer" => $customer->id
            ]);
            if ($statusPaid->paid == true) {
                $order->user_id = $user_id;
                $order->city = $request->city;
                $order->state = $request->state;
                $order->country = $request->country;
                $order->zip_post = $request->zip_postal_code;
                $order->phone = $request->phoneCode . $request->phone;
                $order->address_1 = $request->address_1;
                $order->address_1 = $request->address_1;
                $order->card_name = $request->card_name;
                $order->total_price = $price;
                $order->payment_method =  'stripe';
                $order->status =  'paid';
                $order->save();




                foreach ($domains as $domain) {
                    $payment = new Payments();
                    $payment->price = $domain->price;
                    $payment->order_id = $order->id;
                    $payment->domain_id = $domain->id;
                    $payment->save();
                    $domain->sold = "1";
                    $domain->save();

                    $password = Str::random(10);
                    $domain_user = new DomainUsers();
                    $domain_user->domain_id = $domain->id;
                    $domain_user->user_id = $user_id;
                    $domain_user->password = Hash::make($password);
                    $domain_user->status = 'active';
                    $domain_user->save();


                    $getStripeCustomerId = new CustomerAddress();
                    $getStripeCustomerId->domain_id =  $domain->id;
                    $getStripeCustomerId->active =  '1';
                    $getStripeCustomerId->first_name =  $request->first_name;
                    $getStripeCustomerId->last_name =  $request->last_name;
                    $getStripeCustomerId->stripe_customer_id = $encrypted;
                    $getStripeCustomerId->user_id = $user_id;
                    $getStripeCustomerId->city = $request->city;
                    $getStripeCustomerId->state = $request->state;
                    $getStripeCustomerId->country = $request->country;
                    $getStripeCustomerId->zip_post = $request->zip_postal_code;
                    $getStripeCustomerId->phone = $request->phoneCode . $request->phone;
                    $getStripeCustomerId->address_1 = $request->address_1;
                    $getStripeCustomerId->address_2 = $request->address_2;
                    $getStripeCustomerId->save();

                    $domain_name = $domain->domain_name;
                    $email = $request->email;
                    Mail::send('emails.registration', compact('password','domain_name'), function ($message) use ($email,$domain_name) {
                        $message->from('sales@zdomainname.com', "zDomainName");
                        $message->subject("zDomainName : ".$domain_name ."Purchased ");
                        $message->to($email);
                    });

                    Mail::send('emails.purchase', compact('order'), function ($message) use ($email,$domain_name) {
                        $message->from('sales@zdomainname.com', "zDomainName");
                        $message->subject("zDomainName : ".$domain_name ."Purchased ");
                        $message->to($email);
                    });
                }
                Session::forget('id');
               /* if(!empty($password))
                {

                    Mail::send('emails.registration', compact('password'), function ($message) use ($email) {
                        $message->from('no-reply@temperaturekiosk.com', "New Registration");
                        $message->subject("New Registration");
                        $message->to($email);
                    });
                }*/
               // return redirect()->back()->withMessage("Paid Successfully");
                return Redirect::to($request->root() . "/user/thankyou");

            }
        } catch (\Exception $e) {

            return redirect()->back()->withErrors("something went wrong");
        }

    }

    public function getStates($id)
    {
        $states = States::where('country_id',$id)->get();
        return view('get_states',compact('states'));
    }
}
