<?php

namespace App\Http\Controllers;

use App\Advertisement;
use App\AdvertisimentOffers;
use App\CustomerAddress;
use App\Domains;
use App\GeoLocation;
use App\MetaDescription;
use App\OutSourceSold;
use App\Plans;
use App\Theme;
use App\UserSubscribedDomain;
use Carbon\Carbon;
use GuzzleHttp\Client;
use GuzzleHttp\Exception\GuzzleException;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use SebastianBergmann\CodeCoverage\TestFixture\C;

class HomeController extends Controller
{
    public function index()
    {
        Domains::where('days','<' , Carbon::now())->update([
            'featured' => '0'
        ]);
        $domains  = Domains::where('featured','1')->get();
        $sold = OutSourceSold::where('just_missed','1')->get();
        return view('index',compact('domains','sold'));
    }

    public function privacy()
    {
        return view('privacy');
    }

    public function termsCondition()
    {
        return view('terms_condition');
    }
    public function dashboard(Request $request)
    {
        $subs = UserSubscribedDomain::where('domain_id',base64_decode($request->id))->first();
        if(!isset($subs->id))
        {
            $subs = Domains::find(base64_decode($request->id));
        }
        return view('user/dashboard', compact('subs'));
    }
    public function billinginformation(Request $request)
    {
       $address = CustomerAddress::where('user_id',Auth::user()->id)->where('domain_id',base64_decode($request->id))->where('active',"1")->first();
        return view('user/billinginformation',compact('address'));
    }
    public function paymenthistory()
    {
        return view('user/paymenthistory');
    }
    public function pdfinvoices()
    {
        return view('user/pdfinvoices');
    }
    public function purchaseagreement()
    {
        return view('user/purchaseagreement');
    }
    public function thankyou()
    {
        return view('user/thankyou');
    }

    public function domainProfile(Request $request ,$id,$name)
    {
        $domain = Domains::find(base64_decode($id));
        $ad = Advertisement::where('domain_id',base64_decode($id))->first();
        $theme = Theme::where('domain_id',base64_decode($id))->first();
        $meta = MetaDescription::where('domain_id',base64_decode($id))->first();
        $plan = Plans::where('domain_id',base64_decode($id))->first();
        try {
            $client = new Client();
            $getData = $client->request('GET', "https://ip-geolocation.whoisxmlapi.com/api/v1?apiKey=at_h0xMLQJOy9YEWrLGb2HZlHr4fumlL&ipAddress=".$_SERVER['REMOTE_ADDR'], [
            ]);
            $getResult = json_decode($getData->getBody(), true);
            $ifToday = GeoLocation::whereDate('created_at', Carbon::today())->where('ip',$getResult['ip'])->where('domain_id',base64_decode($id))->first();

            if(isset($ifToday->id))
            {
                $getTime = explode(' ',Carbon::parse($ifToday->created_at)->diffForHumans(now()));

               /* if($getTime[0]>1 && $getTime[1] == 'hours' )
                {*/
                    $geoLocation = new GeoLocation();
                    $geoLocation->domain_id = base64_decode($id);
                    $geoLocation->re_visit = '1';
                    $geoLocation->ip = isset($getResult['ip']) ? $getResult['ip'] : '';
                    $geoLocation->country = isset($getResult['location']['country']) ? $getResult['location']['country'] : '';
                    $geoLocation->region = isset($getResult['location']['region']) ? $getResult['location']['region'] : '';
                    $geoLocation->city = isset($getResult['location']['city']) ? $getResult['location']['city'] : '';
                    $geoLocation->lat = isset($getResult['location']['lat']) ? $getResult['location']['lat'] : '';
                    $geoLocation->lng = isset($getResult['location']['lng']) ? $getResult['location']['lng'] : '';
                    $geoLocation->postal_code = isset($getResult['location']['postal_code']) ? $getResult['location']['postal_code'] : '';
                    $geoLocation->time_zone = isset($getResult['location']['timezone']) ? $getResult['location']['timezone'] : '';
                    $geoLocation->isp = isset($getResult['isp']) ? $getResult['isp'] : '';
                    $geoLocation->connection_type = isset($getResult['connectionType']) ? $getResult['connectionType'] : '';
                    $geoLocation->geoname_id = isset($getResult['location']['geonameId']) ? $getResult['location']['geonameId'] : '';
                    $geoLocation->asn = isset($getResult['as']['asn']) ? $getResult['as']['asn'] : '';
                    $geoLocation->name = isset($getResult['as']['name']) ? $getResult['as']['name'] : '';
                    $geoLocation->route = isset($getResult['as']['route']) ? $getResult['as']['route'] : '';
                    $geoLocation->type = isset($getResult['as']['type']) ? $getResult['as']['type'] : '';
                    $geoLocation->save();
              //  }
            }
            else{
                $geoLocation = new GeoLocation();
                $geoLocation->domain_id = base64_decode($id);
                $geoLocation->ip = isset($getResult['ip']) ? $getResult['ip'] : '';
                $geoLocation->country = isset($getResult['location']['country']) ? $getResult['location']['country'] : '';
                $geoLocation->region = isset($getResult['location']['region']) ? $getResult['location']['region'] : '';
                $geoLocation->city = isset($getResult['location']['city']) ? $getResult['location']['city'] : '';
                $geoLocation->lat = isset($getResult['location']['lat']) ? $getResult['location']['lat'] : '';
                $geoLocation->lng = isset($getResult['location']['lng']) ? $getResult['location']['lng'] : '';
                $geoLocation->postal_code = isset($getResult['location']['postal_code']) ? $getResult['location']['postal_code'] : '';
                $geoLocation->time_zone = isset($getResult['location']['timezone']) ? $getResult['location']['timezone'] : '';
                $geoLocation->isp = isset($getResult['isp']) ? $getResult['isp'] : '';
                $geoLocation->connection_type = isset($getResult['connectionType']) ? $getResult['connectionType'] : '';
                $geoLocation->re_visit = '0';
                $geoLocation->save();
            }
            return view('domain_profile',compact('domain','theme','meta','ad','plan'));


        } catch (GuzzleException $e) {

            return view('domain_profile',compact('domain','theme','meta','ad','plan'));
        }


    }

public function updateAddress(Request $request)
{

    $this->validate($request, [

        'first_name' => 'required|string|max:30',
        'last_name' => 'required|string|max:30',
        'phone' => 'required|string|max:50',
        'address_1' => 'required|string|max:1000',
        'address_2' => 'nullable|string|max:1000',
        'city' => 'required|string|max:45',
        'country' => 'required|string|max:45',
        'state' => 'required|string|max:45',
        'zip_postal_code' => 'required|string|max:25',

    ]);

    $getStripeCustomerId =  CustomerAddress::where('domain_id',base64_decode($request->id))->where('user_id',Auth::user()->id)->where('active',"1")->first();
    $getStripeCustomerId->first_name =  $request->first_name;
    $getStripeCustomerId->last_name =  $request->last_name;
    $getStripeCustomerId->city = $request->city;
    $getStripeCustomerId->state = $request->state;
    $getStripeCustomerId->country = $request->country;
    $getStripeCustomerId->zip_post = $request->zip_postal_code;
    $getStripeCustomerId->phone = $request->phoneCode . $request->phone;
    $getStripeCustomerId->address_1 = $request->address_1;
    $getStripeCustomerId->address_2 = $request->address_2;
    $getStripeCustomerId->save();
    return redirect()->back()->withMessage("Updated Successfully");
}
    public function escrow()
    {
        return view('escrow');
    }
    public function comingsoon()
    {
        return view('comingsoon');
    }
    public function offerone($id)
    {
        $offerAd = AdvertisimentOffers::where('domain_id',base64_decode($id))->first();
        $domain  = Domains::find(base64_decode($id));
        return view('offerone',compact('id','domain','offerAd'));
    }
    public function offertwo( Request $request)
    {
        $this->validate($request, [

            'price' => 'required|numeric',
        ]);
        $domain  = Domains::find(base64_decode($request->id));
        $offerAd = AdvertisimentOffers::where('domain_id',base64_decode($request->id))->first();
        if (!empty($domain->minimum_offer)) {
            if ($domain->minimum_offer > $request->price) {

                return redirect()->back()->WithErrors("Your offer must be equal or higher than $" . number_format($domain->minimum_offer));
            }

        } else if (isset($domainSetting->id)) {
            if ($domainSetting->price > $request->price) {
                return redirect()->back()->WithErrors("Your offer must be equal or higher than $" . number_format($domainSetting->price));
            }
        }

        $id = $request->id;
        $price = $request->price;

        return view('offertwo',compact('id','price','domain','offerAd'));
    }
}
