<?php

namespace App\Http\Controllers;

use App\Domains;
use Illuminate\Http\Request;

class SearchController extends Controller
{
    public function index(Request $request)
    {

        $this->validate($request, [

            'word' => 'nullable|string|max:2000',
            'length_from' => 'nullable|numeric',
            'length_to' => 'nullable|numeric',
            'price_from' => 'nullable|numeric',
            'price_to' => 'nullable|numeric',

        ]);

        if ($request->has('domain_name')) {
            if ($request->domain == 'any') {
                $domains = Domains::where('domain_name', 'like', '%' . $request->domain_name . '%')->where('sold', '0');

            } else {
                $domains = Domains::where('domain_name', 'like', '%' . $request->domain_name . '%' . $request->domain)->where('sold', '0');

            }
            if($request->has('sort_by') && !empty($request->has('sort_by')))
            {
                if($request->sort_by == 'asc')
                {
                    $domains = $domains->orderBy('name', 'ASC');
                }
                else if($request->sort_by == 'desc')
                {
                    $domains = $domains->orderBy('name', 'DESC');
                }
                else if($request->sort_by == 'price_desc')
                {
                    $domains = $domains->orderBy('price', 'DESC');
                }
                else if($request->sort_by == 'price_asc')
                {
                    $domains = $domains->orderBy('price', 'ASC');
                }
                else if($request->sort_by == 'length_asc')
                {
                    $domains = $domains->orderByRaw('CHAR_LENGTH(name)', 'ASC');
                }
                else if($request->sort_by == 'length_desc')
                {
                    $domains = $domains->orderByRaw('CHAR_LENGTH(name)', 'desc');
                }
            }
           $domains = $domains->get();
            return view('search', compact('domains'));
        }
        if ($request->has('word')) {
            if ($request->sort == 'any') {
                $domains = Domains::where('name', 'like', '%' . $request->word . '%')->where('sold', '0');
            } else if ($request->sort == 'start') {
                $domains = Domains::where('name', 'like', $request->word . '%')->where('sold', '0');
            }

            else if ($request->sort == 'end') {
                $domains = Domains::where('name', 'like', '%' . $request->word)->where('sold', '0');
            }

            if(!empty($request->length_from) && !empty($request->length_to))
            {
               $domains = $domains->whereRaw('CHAR_LENGTH(name) between '.$request->length_from.' and '.$request->length_to);

            }

            else if(!empty($request->length_from) && empty($request->length_to))
            {
                $domains = $domains->whereRaw('CHAR_LENGTH(name)  >= '.$request->length_from);

            }

            else if(empty($request->length_from) && !empty($request->length_to))
            {
                $domains = $domains->whereRaw('CHAR_LENGTH(name)  <= '.$request->length_to);

            }

            if(!empty($request->price_from) && !empty($request->price_to))
            {
                $domains = $domains->whereRaw('price between '.$request->price_from.' and '.$request->price_to);

            }

            else if(!empty($request->price_from) && empty($request->price_to))
            {
                $domains = $domains->whereRaw('price >= '.$request->price_from);

            }

            else if(empty($request->price_from) && !empty($request->price_to))
            {
                $domains = $domains->whereRaw('price  <= '.$request->price_to);

            }

            if($request->has('sort_by') && !empty($request->has('sort_by')))
            {
                if($request->sort_by == 'asc')
                {
                    $domains = $domains->orderBy('name', 'ASC');
                }
                else if($request->sort_by == 'desc')
                {
                    $domains = $domains->orderBy('name', 'DESC');
                }
                else if($request->sort_by == 'price_desc')
                {
                    $domains = $domains->orderBy('price', 'DESC');
                }
                else if($request->sort_by == 'price_asc')
                {
                    $domains = $domains->orderBy('price', 'ASC');
                }
                else if($request->sort_by == 'length_asc')
                {
                    $domains = $domains->orderByRaw('CHAR_LENGTH(name)', 'ASC');
                }
                else if($request->sort_by == 'length_desc')
                {
                    $domains = $domains->orderByRaw('CHAR_LENGTH(name)', 'desc');
                }
            }

            $domains = $domains->get();
            return view('search', compact('domains','request'));
        }
        return view('search');
    }
}
